<?php
/*---------------------------------------------------------------*/
/*
    Titre : Optimiser un chaine pour la réécriture d'URL                                                                
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=345
    Auteur           : crocxx                                                                                             
    Date dition     : 22 Fv 2008                                                                                        
    Date mise  jour : 09 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - refactoring du code en PHP 7                                                                                        
    - fonctionnement du code vérifié                                                                                    
    - correction du code                                                                                                  
    - amélioration du code                                                                                               
    - modification de la description                                                                                      
*/
/*---------------------------------------------------------------*/

    function OptimiseUrl($chaine)
    {    
        $chaine=strtolower($chaine);
          
        $accents = Array("/é/", "/è/", "/ê/", "/ç/", "/à/", "/â/", "/î/",
 "/ï/","/ù/", "/ô/");
        $sans = Array("e", "e", "e", "c", "a", "a", "i", "i", "u", "o");
         
        $chaine = preg_replace($accents, $sans,$chaine);    
         
          
        $entre = array(' ','?', '!', '.', ',', ':', "'", '&', '(', ')','"','/');
        $sortie = array('-', '-', '-', '-', '-', '-', '-', '-', '-', '-','-');
        $chaine = str_replace($entre, $sortie, $chaine);
         
         
        $modifchaine=true;
        while($modifchaine==true) 
        {
            $modifchaine=false;
             
            if(preg_match('#--#',$chaine))
            {
                $chaine = str_replace('--','-',$chaine);
                $modifchaine=true;        
            }
        }
         
        return $chaine; 
    }
?>